
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;
import net.proteanit.sql.DbUtils;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author Gaurav
 */
public class Attendance extends javax.swing.JPanel {

    /**
     * Creates new form branch
     */
    Connection conn;
    PreparedStatement ps;
    ResultSet rs;
    
    
    public Attendance() {
        
        initComponents();
        conn = MySQLConnect.getConnection();
       setBranch();

        
    }
    
    public static void main(String args[]){
        
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel3 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        lblheader = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        txtsearchdata = new javax.swing.JPanel();
        id = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        cmbBranch = new javax.swing.JComboBox<>();
        cmbSubject = new javax.swing.JComboBox<>();
        jLabel4 = new javax.swing.JLabel();
        cmbSemester = new javax.swing.JComboBox<>();
        jPanel2 = new javax.swing.JPanel();
        tableData = new javax.swing.JScrollPane();
        jtbStudentAttendance = new javax.swing.JTable();
        jPanel4 = new javax.swing.JPanel();
        jLabel6 = new javax.swing.JLabel();
        txtsearch = new javax.swing.JTextField();
        jSeparator3 = new javax.swing.JSeparator();
        lbladd = new javax.swing.JLabel();
        lbldelete = new javax.swing.JLabel();
        lblAdd = new javax.swing.JLabel();

        jLabel3.setText("jLabel3");

        setMaximumSize(new java.awt.Dimension(880, 684));

        jPanel1.setBackground(new java.awt.Color(255, 255, 255));

        lblheader.setBackground(new java.awt.Color(255, 255, 255));
        lblheader.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 2));
        lblheader.setPreferredSize(new java.awt.Dimension(880, 80));

        jLabel1.setFont(new java.awt.Font("SansSerif", 0, 30)); // NOI18N
        jLabel1.setText("Manage Attendance");

        javax.swing.GroupLayout lblheaderLayout = new javax.swing.GroupLayout(lblheader);
        lblheader.setLayout(lblheaderLayout);
        lblheaderLayout.setHorizontalGroup(
            lblheaderLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(lblheaderLayout.createSequentialGroup()
                .addGap(107, 107, 107)
                .addComponent(jLabel1)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        lblheaderLayout.setVerticalGroup(
            lblheaderLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(lblheaderLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addContainerGap(26, Short.MAX_VALUE))
        );

        txtsearchdata.setBackground(new java.awt.Color(255, 255, 255));
        txtsearchdata.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 2));

        id.setFont(new java.awt.Font("SansSerif", 0, 18)); // NOI18N
        id.setText("Branch");

        jLabel2.setFont(new java.awt.Font("SansSerif", 0, 18)); // NOI18N
        jLabel2.setText("Subject");

        cmbBranch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmbBranchActionPerformed(evt);
            }
        });

        cmbSubject.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                cmbSubjectMouseClicked(evt);
            }
        });
        cmbSubject.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmbSubjectActionPerformed(evt);
            }
        });

        jLabel4.setFont(new java.awt.Font("SansSerif", 0, 18)); // NOI18N
        jLabel4.setText("Semester");

        cmbSemester.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "First", "Second", "Third", "Fourth", "Fifth", "Sixth" }));
        cmbSemester.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmbSemesterActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout txtsearchdataLayout = new javax.swing.GroupLayout(txtsearchdata);
        txtsearchdata.setLayout(txtsearchdataLayout);
        txtsearchdataLayout.setHorizontalGroup(
            txtsearchdataLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(txtsearchdataLayout.createSequentialGroup()
                .addGap(23, 23, 23)
                .addGroup(txtsearchdataLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(id, javax.swing.GroupLayout.PREFERRED_SIZE, 77, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(txtsearchdataLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(cmbSubject, javax.swing.GroupLayout.PREFERRED_SIZE, 200, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(cmbBranch, javax.swing.GroupLayout.PREFERRED_SIZE, 200, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 134, Short.MAX_VALUE)
                .addComponent(jLabel4)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(cmbSemester, javax.swing.GroupLayout.PREFERRED_SIZE, 200, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(42, 42, 42))
        );
        txtsearchdataLayout.setVerticalGroup(
            txtsearchdataLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(txtsearchdataLayout.createSequentialGroup()
                .addGap(30, 30, 30)
                .addGroup(txtsearchdataLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(id)
                    .addComponent(cmbBranch, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(cmbSemester, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 57, Short.MAX_VALUE)
                .addGroup(txtsearchdataLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(cmbSubject, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(17, 17, 17))
        );

        jPanel2.setBackground(new java.awt.Color(255, 255, 255));

        jtbStudentAttendance.setAutoCreateRowSorter(true);
        jtbStudentAttendance.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null}
            },
            new String [] {
                "student id", "student name", "attendance"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Object.class, java.lang.Object.class, java.lang.String.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        jtbStudentAttendance.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        jtbStudentAttendance.setGridColor(new java.awt.Color(255, 255, 255));
        jtbStudentAttendance.setSelectionBackground(new java.awt.Color(66, 133, 140));
        jtbStudentAttendance.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jtbStudentAttendanceMouseClicked(evt);
            }
        });
        tableData.setViewportView(jtbStudentAttendance);

        jPanel4.setBackground(new java.awt.Color(255, 255, 255));
        jPanel4.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 2));

        jLabel6.setFont(new java.awt.Font("SansSerif", 0, 18)); // NOI18N
        jLabel6.setText("Search");

        txtsearch.setBorder(null);
        txtsearch.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                txtsearchKeyPressed(evt);
            }
        });

        jSeparator3.setForeground(new java.awt.Color(0, 0, 0));

        lbladd.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));

        lbldelete.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));

        lblAdd.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Icons/ADD.png"))); // NOI18N
        lblAdd.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                lblAddMouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addGap(30, 30, 30)
                .addComponent(jLabel6)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(jSeparator3, javax.swing.GroupLayout.PREFERRED_SIZE, 194, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(48, 48, 48)
                        .addComponent(lbladd))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(txtsearch, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(151, 151, 151)
                        .addComponent(lblAdd)))
                .addGap(408, 408, 408)
                .addComponent(lbldelete))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGap(99, 99, 99)
                        .addComponent(lbladd))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGap(50, 50, 50)
                        .addComponent(lbldelete)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txtsearch, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel6)
                    .addComponent(lblAdd))
                .addGap(0, 0, 0)
                .addComponent(jSeparator3, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(28, 28, 28))
        );

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(tableData)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, 852, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 30, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 71, Short.MAX_VALUE)
                .addComponent(tableData, javax.swing.GroupLayout.PREFERRED_SIZE, 210, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(38, 38, 38)
                .addComponent(txtsearchdata, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addComponent(lblheader, javax.swing.GroupLayout.DEFAULT_SIZE, 882, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(lblheader, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(30, 30, 30)
                .addComponent(txtsearchdata, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    private void jtbStudentAttendanceMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jtbStudentAttendanceMouseClicked
        // TODO add your handling code here:
     
            String status = (String) jtbStudentAttendance.getValueAt(jtbStudentAttendance.getSelectedRow(), 2);
            if(status.equals("Absent")){
                jtbStudentAttendance.setValueAt("Present",jtbStudentAttendance.getSelectedRow() , 2);
            }else{
                jtbStudentAttendance.setValueAt("Absent", jtbStudentAttendance.getSelectedRow(), 2);
            }
        
    }//GEN-LAST:event_jtbStudentAttendanceMouseClicked

    private void lblAddMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_lblAddMouseClicked
        // TODO add your handling code here:
        for(int i =0;i<jtbStudentAttendance.getRowCount();i++){
            try {
                String query;
                if(jtbStudentAttendance.getValueAt(i, 2).equals("Present")){
                    query = "update attendance set subject_counter = subject_counter + 1 , student_counter = student_counter + 1, status = '"+jtbStudentAttendance.getValueAt(i, 2)+"' where student_id="+jtbStudentAttendance.getValueAt(i, 0)+" and subject_id="+getSubjectId();
                }else{
                    query = "update attendance set subject_counter = subject_counter + 1 , student_counter = student_counter, status = '"+jtbStudentAttendance.getValueAt(i, 2)+"' where student_id="+jtbStudentAttendance.getValueAt(i, 0)+" and subject_id="+getSubjectId();;
                }
                ps = conn.prepareStatement(query);
                boolean execute = ps.execute();
            } catch (SQLException ex) {
                Logger.getLogger(Attendance.class.getName()).log(Level.SEVERE, null, ex);
            }
           
        }
         updatePercentage();
    }//GEN-LAST:event_lblAddMouseClicked

    private void cmbBranchActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmbBranchActionPerformed
        // TODO add your handling code here:
   
    }//GEN-LAST:event_cmbBranchActionPerformed

    private void cmbSemesterActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmbSemesterActionPerformed
        // TODO add your handling code here:
     setSubject();
    }//GEN-LAST:event_cmbSemesterActionPerformed

    private void cmbSubjectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmbSubjectActionPerformed
        // TODO add your handling code here:
        fillDataTable();
    }//GEN-LAST:event_cmbSubjectActionPerformed

    private void cmbSubjectMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_cmbSubjectMouseClicked
        // TODO add your handling code here:

    }//GEN-LAST:event_cmbSubjectMouseClicked

    private void txtsearchKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtsearchKeyPressed
        // TODO add your handling code here:
   
    }//GEN-LAST:event_txtsearchKeyPressed
    void setBranch(){
        String query = "select branch_name from branch";
        
        try {
            ps = conn.prepareStatement(query);
            rs = ps.executeQuery();
            while(rs.next()){
                cmbBranch.addItem(rs.getString("branch_name"));
               
            }
        } catch (SQLException ex) {
           
        }
    }
    void setSubject(){
         int semester_id =cmbSemester.getSelectedIndex()+1;
         System.out.println(semester_id);
        String query = "select subject_name from subject where branch_id="+getBranchId()+" and semester_id="+semester_id;
        cmbSubject.removeAllItems();
        try {
            ps = conn.prepareStatement(query);
            rs = ps.executeQuery();
            while(rs.next()){
                cmbSubject.addItem(rs.getString("subject_name"));
               
            }
        } catch (SQLException ex) {
           
        }
    }
    private int getBranchId(){
    int branch_id = 0;
    String branch_n = cmbBranch.getSelectedItem().toString();
    String query = "Select * from branch where branch_name = ?";
        try {
            ps = conn.prepareStatement(query);
            ps.setString(1,branch_n);
            rs = ps.executeQuery();
            if(rs.next()){
                branch_id = rs.getInt("branch_id");
            }
        } catch (SQLException ex) {
            
        }
   return branch_id;
}
    private int getSubjectId(){
    int subject_id = 0;
    String subject_name = cmbSubject.getSelectedItem().toString();
    String query = "Select * from subject where subject_name = ?";
        try {
            ps = conn.prepareStatement(query);
            ps.setString(1,subject_name);
            rs = ps.executeQuery();
            if(rs.next()){
                subject_id = rs.getInt("subject_id");
            }
        } catch (SQLException ex) {
            
        }
   return subject_id;
}
    private void fillDataTable(){
        int semester_id = cmbSemester.getSelectedIndex()+1;
        int branch_id = getBranchId();
        String query = "SELECT student.student_id,student_name,status FROM student join attendance on student.student_id = attendance.student_id WHERE student.semester_id ="+semester_id+" and student.branch_id = "+branch_id;
        try {
            ps = conn.prepareStatement(query);
           
            rs = ps.executeQuery();
            jtbStudentAttendance.setModel(getMyTableModel(DbUtils.resultSetToTableModel(rs)));
        } catch (SQLException ex) {
            Logger.getLogger(Branch.class.getName()).log(Level.SEVERE, null, ex);
        }
        
    }
    private DefaultTableModel getMyTableModel(TableModel dtm){
        int row = dtm.getRowCount();
        int col = dtm.getColumnCount();
        Object[][] jTableData = new Object[row][col];
        for(int i = 0;i<row;i++){
            for(int j = 0;j<col;j++){
                jTableData[i][j] = dtm.getValueAt(i, j);
            }
        }
        String[] colHeads = {"student_id","Student_name","status"};
        DefaultTableModel myModel;
        myModel = new DefaultTableModel(jTableData,colHeads){
            
            @Override
            public boolean isCellEditable(int row, int column){
                return false;
            }
        };
         return myModel;
    }
    void updatePercentage(){
        int subject_counter =0;
        int student_counter =0;
        for(int i =0;i<jtbStudentAttendance.getRowCount();i++){
            int student_id = (int) jtbStudentAttendance.getValueAt(i,0);
            String query = "select * from attendance where student_id="+student_id+" and subject_id ="+getSubjectId();
            try {
                ps = conn.prepareStatement(query);
                rs = ps.executeQuery();
                if(rs.next()){
                    subject_counter=rs.getInt("subject_counter");
                    student_counter=rs.getInt("student_counter");
                } 
            } catch (SQLException ex) {
                Logger.getLogger(Attendance.class.getName()).log(Level.SEVERE, null, ex);
            }
           double percentage = (student_counter /  subject_counter)*100;
           query ="update attendance set percentage="+percentage+" where student_id ="+student_id+" and subject_id="+getSubjectId();
            try {
                ps = conn.prepareStatement(query);
                ps.execute();
            } catch (SQLException ex) {
                Logger.getLogger(Attendance.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox<String> cmbBranch;
    private javax.swing.JComboBox<String> cmbSemester;
    private javax.swing.JComboBox<String> cmbSubject;
    private javax.swing.JLabel id;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JTable jtbStudentAttendance;
    private javax.swing.JLabel lblAdd;
    private javax.swing.JLabel lbladd;
    private javax.swing.JLabel lbldelete;
    private javax.swing.JPanel lblheader;
    private javax.swing.JScrollPane tableData;
    private javax.swing.JTextField txtsearch;
    private javax.swing.JPanel txtsearchdata;
    // End of variables declaration//GEN-END:variables
}
